      Program SMallx
      Include 'SMallx.inc'
      Integer Iev
C---Standard LEP event common block
      Integer NMXHEP,NEVHEP,NHEP,ISTHEP,IDHEP,JMOHEP,JDAHEP
      Real PHEP,VHEP,EVWGT
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
C---Event weight
C   N.B. weights must be renormalized to momentum sum
      COMMON/HEPWGT/EVWGT
C---Initialize run
      Call SMinit
C---Initialize analysis
      Call SMabeg
      Do 100 Iev=1,Nev
C---Initialize event
      Call SMinfn
C---Small-x gluon branching process
      Call SMbran
C---Off-shell photon-gluon fusion
      Call SMhard
C---Transfer event data to standard LEP event common block
      Call SMhevt
C---Analyse event
      Call SManal
C---Print some events
      If (NEVHEP.le.Maxpr.and.EVWGT.ne.0.) Call SMprev
  100 Continue
C---Terminate analysis
      Call SMaend
      End
C------------------------------------------------------------------------
      Subroutine SMinit
C--Sets input parameters
      Include 'SMallx.inc'
      Real pbeam1,pbeam2
      Integer Lux,K1,K2
      QCDLam=0.2
      Qg=0.25
      Qs=1.
C      Qs=Sqrt(5.)
      Qx=Qs/Sqrt(2.)
      Is=50708061
c changed hannes:     Call SMrset(Is)
      LUX = 4
      K1=0
      K2=0
      CALL RLUXGO(LUX,IS,K1,K2)      
c end changed hannes
      Maxpr=50
      Nmongo=27
C---Number of events
      Nev=100000
      Print *
      Print *,' Number of events requested:',Nev
C---Timelike evolution of emitted gluons?
C      tevol=.false.
      tevol=.true.
C---One loop or all loops evolution?
      onel=.false.
C      onel=.true. 
C---Power or one-loop form for input?
C      powin=.false.
      powin=.true.
c--power input form is (1/x)**pow0*(1-x)**pow1
C      pow0=0.5
      pow0=0.0
      pow1=5.
C      pow1=0.
c--1 loop input form is Exp(a0*SqrtLn1/x)*(1-x)**pow1
C      a0=3.56
C      a0=1.0
C--Heavy quark electroproduction at HERA
C      pbeam1=30.
C      pbeam2=820.
C--Heavy quark electroproduction at LHC
      pbeam1=80.
      pbeam2=8000.
C-- Eloisatron
C      pbeam1=5000.
C      pbeam2=100000.
C--Charm
C      Qmas=1.5
C      Ichg=2
C      Idq=4
C--Bottom
      Qmas=5.
      Ichg=1
      Idq=5
C--Light quarks
C      Qmas=Qg
C      Ichg=3
C      Idq=2
C      Rdq=6.*Rgen(1)
C      If (Rdq.lt.2.) Idq=1
C      If (Rdq.lt.1.) Idq=3
C--Magic conversion factor for gluons->charged hadrons
C      Gluch=2.5
      Gluch=1.0
C--Hot spot study?
C      hspot=.true.
      hspot=.false.
C--Set up beams: 1=electron, 2=proton
      p1(1)=0.
      p1(2)=0.
      p1(3)=-pbeam1
      p1(5)=0.00051
      p1(4)=Sqrt(p1(3)**2+p1(5)**2)
      p2(1)=0.
      p2(2)=0.
      p2(3)=pbeam2
      p2(5)=0.93827
      p2(4)=Sqrt(p2(3)**2+p2(5)**2)
      espec(5)=p1(5)
      pspec(5)=p2(5)
      Sbig=p1(5)**2+p2(5)**2+2.*(p1(4)*p2(4)-p1(3)*p2(3))
C--Limit for branching
      Imax=1000    
C--Gluon momentum fraction
      Xnor=0.5
C--xmin.le.kinematic limit
      xymin=4.*Qmas**2/Sbig
      xmin=xymin
      xmax=.9999999
C--y range (y=momentum fraction of virtual photon)
      ymin=xymin
      ymax=.9999999
C--Q range
      me=0.511E-3
      Qmin=ymin*me
      Qmax=sqrt(ymax*Sbig)
      If (hspot) then
C  Min Q value
        Qmin=sqrt(20.)
C  Min x of trigger jet
        Xmjtrg=0.01
        Ppjtrg=Xmjtrg*2.*pbeam2
C  Min pt of trigger jet
        Ptjtrg=Qmin
C  Min tan-theta of trigger jet
        Thjtrg=Tan(10.*3.14159/180.)
        Print *,' Hot spot study with parameters:'
        Print *,' Min Q,xj,ptj,tanj =',Qmin,Xmjtrg,Ptjtrg,Thjtrg
      Endif

C--Nf=0: Capb=C_A/pi/b
      Capb=12./11.

      Tg=Log(Qg/QCDLam)
      Tgg=Tg+Log(2.)
      Ts=Log(Qs/QCDLam)

      Print *
      If (onel) then
        Print *,' Running alpha, Q-ordering => 1-loop'
      Else
        Print *,' Running alpha, Angle-ordering => all loops'
      Endif
      Print *
      Print *,' Qmax,Qg,Qs,QCDLam =',Qmax,Qg,Qs,QCDLam
      Print *
      Print *,' Qmas,xmin =',Qmas,xmin
      Print *
      If (powin) then
c--power input form
        Print *,' Input xF(x) is (1/x)**p0*(1-x)**p1'
c--Lipatov exponent
c        p0=2.*Log(2.)*Capb/Ts
        Print *,' p0,p1 =',pow0,pow1
        If (pow0.ne.0.) then
          xmp0=1.-xmin**pow0
          q0=-1./pow0
        Endif
      Else
c--1 loop input form
        Print *,' Input xF(x) is Exp(a0*SqrtLn1/x)*(1-x)**p1'
        Print *,' a0,p1 =',a0,pow1
c  u=sqrt(ln1/x)
        umax=Sqrt(-Log(xmin))
        emax=Exp(a0*umax)-1.
      Endif
      Jev=0
      End
C------------------------------------------------------------------------
      Subroutine SMabeg
C--Sets up analysis and histograms
      Include 'SMallx.inc'
      Real xl10min,Ql10min,Ql10max
      Nmongo=27
      Nbin=25
      xl10min=Log10(xmin)
      Ql10min=2.*Log10(Qmin)
      Ql10max=2.*Log10(Qmax)
      Call Gbook1(1,' Input xF(x) vs Log_10(x_g)',Nbin,xl10min,0.)
      Call Gbook1(2,' Output xF(x) vs Log_10(x_g)',Nbin,xl10min,0.)
      Call Gbook1(4,' x_g*dsig/dx_g vs Log_10(x_g)',Nbin,xl10min,0.)
      Call Gbook1(5,' Struck gluon k_t (Wt)',Nbin,0.,50.)
      Call Gbook1(6,' Struck gluon k_t (Wt*Sig)',Nbin,0.,50.)
      Call Gbook1(8,' Luminosity vs sqrt s_L',Nbin,0.,100.)
      Call Gbook1(9,' Assoc charged multiplicity',Nbin,0.5,63.)
      Call Gbook1(10,' Charged <n> vs Log_10(x_Bj)',Nbin,xl10min,0.)
      Call Gbook1(14,' x_Bj*dsig/dx_Bj vs Log_10(x_Bj)',Nbin,xl10min,0.)
      Call Gbook1(24,' y*dsig/dy vs Log_10(y)',Nbin,xl10min,0.)
      Call Gbook1(34,' Q^2*dsig/dQ^2 vs Log_10(Q^2)',
     & Nbin,Ql10min,Ql10max)
      Call Gbook1(44,' Heavy quark rapidity',Nbin,-6.25,6.25)
      Call Gbook1(45,' Heavy quark pair rapidity',Nbin,-6.25,6.25)
      Call Gbook1(54,' Heavy quark rap diff',Nbin,-6.25,6.25)
      Call Gbook1(55,' Multiplicity vs rapidity',Nbin,-6.25,6.25)
      Call Gbook1(56,' Trans energy vs rapidity',Nbin,-6.25,6.25)
      Call Gbook1(64,' Heavy quark azimuth diff',Nbin,0.,180.)
      Call Gbook1(74,' Heavy quark pT',Nbin,0.,50.)
      Call Gbook1(84,' Heavy quark pair pT',Nbin,0.,50.)
      Call Gbook1(98,'Wtd:5=Qo<Qg,10=Qh>Q,15=x<xmin,20=Qt<Qg,25=xF',
     & 30,0.,30.)
      Call Gbook1(99,'Unw:5=Qo<Qg,10=Qh>Q,15=x<xmin,20=Qt<Qg,25=xF',
     & 30,0.,30.)
      Xini=0.
      Xfin=0.
      Xfi2=0.
      Sigtot=0.
      Sigto2=0.
      Sigto3=0.
      Mulsum=0.
      Mulsu2=0.
      Mulsu3=0.
      End
C------------------------------------------------------------------------
      Subroutine SMaend
C--Final analysis
      Include 'SMallx.inc'
      Real Fscale,Errorf,Hscale,xlr
      xlr=-Log(xmin)
      Fscale=Xnor/Xfin
      Errorf=Xfi2/Xfin**2+Sigto2/Sigtot**2-2.*Sigto3/Xfin/Sigtot
      If (Errorf.lt.0.) Errorf=0.
      Print *
      Print *,'  Sigma-total (nb) =',Sigtot*Fscale,
     & ' +/-',Sqrt(Errorf)*Sigtot*Fscale
      Errorf=Mulsu2/Mulsum**2+Sigto2/Sigtot**2-2.*Mulsu3/Mulsum/Sigtot
      If (Errorf.lt.0.) Errorf=0.
      Print *,'  Init state <nch> =',Mulsum/Sigtot,
     & ' +/-',Sqrt(Errorf)*Mulsum/Sigtot
      Print *,'  Final mom sum    =',Xnor*Xfin/Xini
      Write (Nmongo,*) ' (Ecm, Qmas =',Sqrt(Sbig),Qmas
      Write (Nmongo,*) ' (Nev, Onel =',Nev,onel
      Write (Nmongo,*) ' (Qg, Qs =',Qg,Qs
      Write (Nmongo,*) ' (Total cross section in nb =',Sigtot*Fscale
      Write (Nmongo,*) ' (Mean charged multiplicity =',Mulsum/Sigtot
      Call Gopera(10,'/',14,10,1.,1.)
      Fscale=Fscale*Nbin
      Hscale=Fscale/xlr
      Call Gscale(1,Hscale*Xfin/Xini)
      Call Gscale(2,Hscale)
      Call Gscale(4,Hscale)
      Call Gscale(14,Hscale)
      Call Gscale(24,Hscale)
      Hscale=Fscale/50.
      Call Gscale(5,Hscale)
      Call Gscale(6,Hscale)
      Call Gscale(8,Hscale/2.)
      Call Gscale(74,Hscale)
      Call Gscale(84,Hscale)
      Call Gscale(34,Fscale/Log(Qmax/Qmin))
      Hscale=Fscale/12.5
      Call Gscale(44,Hscale)
      Call Gscale(45,Hscale)
      Call Gscale(54,Hscale)
      Hscale=1./(Sigtot*2.5)
      Call Gscale(9,Hscale)
      Hscale=Nbin/(Sigtot*12.5)
      Call Gscale(55,Hscale)
      Call Gscale(56,Hscale)
      Call Gscale(64,Fscale/180.)
c      Call Gmongo(1,Nmongo,10,1)
c      Call Gmongo(2,Nmongo,10,1)
c      Call Gmongo(4,Nmongo,10,1)
c      Call Gmongo(5,Nmongo,10,1)
c      Call Gmongo(6,Nmongo,10,1)
c      Call Gmongo(8,Nmongo,10,1)
c      Call Gmongo(9,Nmongo,10,1)
c      Call Gmongo(10,Nmongo,10,1)
c      Call Gmongo(14,Nmongo,10,1)
c      Call Gmongo(24,Nmongo,10,1)
c      Call Gmongo(34,Nmongo,10,1)
c      Call Gmongo(44,Nmongo,10,1)
c      Call Gmongo(45,Nmongo,10,1)
c      Call Gmongo(54,Nmongo,10,1)
c      Call Gmongo(55,Nmongo,10,1)
c      Call Gmongo(56,Nmongo,10,1)
c      Call Gmongo(64,Nmongo,10,1)
c      Call Gmongo(74,Nmongo,10,1)
c      Call Gmongo(84,Nmongo,10,1)
      Call Gclear
      End
C------------------------------------------------------------------------
      Subroutine SManal
C--Event analysis
      Include 'SMallx.inc'
      Integer NMXHEP,NEVHEP,NHEP,ISTHEP,IDHEP,JMOHEP,JDAHEP
      Real PHEP,VHEP,EVWGT
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
C---Event weight
C   N.B. weights must be renormalized to momentum sum
      COMMON/HEPWGT/EVWGT
      Integer I,Nbad
      Real xgl10,Qtot,Ql10val,yl10val,xBl10,rphq,rpq1,pthq,ptq1,dphi,
     & Mult,sL,SMurap,phard(4),psum(4)
      Data Nbad/0/
      Xini=Xini+x0
      Call Gfill1(1,Log10(x0),1.)
      If (Excode.ne.0.0) then
        Call Gfill1(98,Excode,P(6,I))
        Call Gfill1(99,Excode,1.)
        return
      Endif
      Qtot=Sqrt(P(1,Ifin)**2+P(2,Ifin)**2)
      If (Qtot.lt.2.*Qmas) then
        Xfin=Xfin+Wt*xg
        Xfi2=Xfi2+(Wt*xg)**2
        Call Gfill1(2,Log10(xg),Wt)
      Endif
      Call Gfill1(5,Qtot,Wt)
      sL=xg*yphton*Sbig
      Call Gfill1(8,Sqrt(sL),Wt*Wini/(137.*3.14159))
      If (Wsig.le.0.0) return
      xgl10=Log10(xg)
      Ql10val=2.*Log10(Qval)
      yl10val=Log10(yphton)
      xBl10=Ql10val-yl10val-Log10(Sbig)
      Call Gfill1(4,xgl10,Wsig)
      Call Gfill1(6,Qtot,Wsig)
      Call Gfill1(14,xBl10,Wsig)
      Call Gfill1(24,yl10val,Wsig)
      Call Gfill1(34,Ql10val,Wsig)
      rphq=SMurap(p3)
      pthq=Sqrt(p3(1)**2+p3(2)**2)
      Call Gfill1(44,rphq,Wsig)
      Call Gfill1(74,pthq,Wsig)
      rpq1=rphq
      rphq=SMurap(p4)
      ptq1=pthq
      pthq=Sqrt(p4(1)**2+p4(2)**2)
      If (pthq.eq.0.) then
       dphi=0.
      Else
       dphi=(p3(1)*p4(1)+p3(2)*p4(2))/(ptq1*pthq)
       If (dphi.gt.1.) then
         dphi=0.
       Elseif (dphi.lt.-1.) then
         dphi=180.
       Else
         dphi=180.*acos(dphi)/3.142
       Endif
      Endif
      Call Gfill1(44,rphq,Wsig)
      Call Gfill1(54,rphq-rpq1,Wsig)
      Call Gfill1(64,dphi,Wsig)
      Call Gfill1(74,pthq,Wsig)
      Call SMvsum(4,p3,p4,phard)
      rphq=SMurap(phard)
      pthq=Sqrt(phard(1)**2+phard(2)**2)
      Call Gfill1(45,rphq,Wsig)
      Call Gfill1(84,pthq,Wsig)  
      Sigtot=Sigtot+Wsig
      Sigto2=Sigto2+Wsig**2
      Sigto3=Sigto3+Wsig*Wt*xg
      Mult=0.
      Call SMvsum(4,PHEP(1,1),PHEP(1,2),psum)
      Do 800 I=1,NHEP
      If (ISTHEP(I).EQ.1) then
        Call SMvdif(4,psum,PHEP(1,I),psum)
        If (IDHEP(I).eq.21) then
          rphq=SMurap(PHEP(1,I))
          Call Gfill1(55,rphq,EVWGT*Gluch)
          pthq=Sqrt(PHEP(1,I)**2+PHEP(2,I)**2)
          Call Gfill1(56,rphq,EVWGT*pthq)
          Mult=Mult+Gluch
        Endif
      Endif
  800 Continue
      Do 810 I=1,4
      If (Abs(psum(I)).gt.0.1) then
        Nbad=Nbad+1
        Print *,' Bad momentum sum =',psum
        Call SMprev
        If (Nbad.gt.10) Stop
      Endif
  810 Continue
      Call Gfill1(9,Mult,Wsig)
      Call Gfill1(10,xBl10,Wsig*Mult)
      Mulsum=Mulsum+Wsig*Mult
      Mulsu2=Mulsu2+(Wsig*Mult)**2
      Mulsu3=Mulsu3+Wsig*Mult*Wsig
      End
C------------------------------------------------------------------------
      Subroutine SMbran
C--Small x branching algorithm
      Include 'SMallx.inc'
      Real sL,qtx,qty,QQtx,QQty,TQt,ynow,qt,ybar,ximax
      Integer I,j,Nbad
      Data Nbad/0/
      Excode=0.
      I=0
      Told=Ts
      Nsoft=0
      ximax=(xgbar+yphton)/(xg+yphbar)
c--loop over branches
  100 Ifin=I
      Jfin=Ifin
C--Limit on Qtem
C      sL=xg*yphton*Sbig
C      Qbar=Sqrt(sL)
C      Qbar=sL/Sqrt(sL-Qval**2)
C      Qbar=Sqrt(sL+Qval**2)
      Qbar=2.*Qmas
      Qhard=Qbar
C---NEW STOPPING CONDITION!!-----------------
      If (ximax.gt.0.) then
        Qbar=xg*sqrt(Sbig*ximax)
      Else
        Qbar=-1.
      Endif
C--------------------------------------------
C      If (hspot) Qbar=Qval
C      Pmax=Qbar
C--Find Qtem
C  f(Qtem)=SMrgen(2)*f(Qold)
      Call SMqtem(.false.)
      If (Qtem.gt.Qbar) go to 600
c--Compute provisional qt and Qt
      Call SMrazm(Qtem,qtx,qty)
      QQtx=P(1,I)+qtx
      QQty=P(2,I)+qty
      QQt=Sqrt(QQtx**2+QQty**2)
      If (QQt.le.Qg) then
        Told=Ttem
        Call Gfill1(98,20.,P(6,I))
        Call Gfill1(99,20.,1.)
       go to 100
      Endif
      TQt=Log(QQt/QCDLam)
      Call SMzval
C      Call SMzold
c--Compute true qt and Qt
      ynow=1.-znow
      qt=Qtem*ynow
      ybar=qt**2/(xg*ynow*Sbig)
      qtx=qtx*ynow
      qty=qty*ynow
      QQtx=P(1,I)+qtx
      QQty=P(2,I)+qty
      QQt=Sqrt(QQtx**2+QQty**2)
      If (onel.and.QQt.gt.Qhard) go to 600
      If (QQt.le.Qg) then
        Told=Ttem
        Call Gfill1(98,21.,P(6,I))
        Call Gfill1(99,21.,1.)
        go to 100
      Endif
c---Exit conditions for outside kinematic limits
      If (QQt.gt.Qmax) then
        Excode=10.
        Return
      Endif
      xg=znow*xg
      xgbar=xgbar-ybar
c---Exit conditions for xg < xmin
      If (xg.le.xmin) then
        Excode=15.
        Return
      Endif
      ximax=(xgbar+yphton)/(xg+yphbar)
c--add a branch
      I=I+1
      P(1,I)=QQtx
      P(2,I)=QQty
      P(3,I)=xg*p2(3)+xgbar*p1(3)
      P(4,I)=xg*p2(4)+xgbar*p1(4)
      Call SMumas(P(1,I))
C--Update weight
      Wt=P(6,I-1)*wg
      P(6,I)=Wt
      P(7,I)=0.
      P(8,I)=qt
      If (I.eq.Imax) then
        Print *, ' Ran out of space on event',Jev
        Call SMprev
        return
      Endif
      If (onel) then
c--1-loop
        Told=Ttem
      Else
c--all loops
        Told=Ttem+Log(znow)
        If (Told.lt.Tg) then 
          Told=Tg
          Call Gfill1(98,5.,P(6,I))
          Call Gfill1(99,5.,1.) 
          go to 100
       Endif
      Endif
      go to 100
C--End spacelike branching
  600 Ifin=I
      Call SMvequ(5,P(1,Ifin),q2)
C--Timelike branching
      Jfin=Ifin
      Call SMtimb
      If (Wt.lt.0.) then
        Print *,' Negative weight =',Wt
        Call SMprev
        Stop
      Endif
      End
C------------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION SMDERF(DX)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL LERF
C
      DIMENSION P1(4),Q1(3), P2(8),Q2(7), P3(5),Q3(4)
C
C     ******************************************************************
C
C     ENTRY POINTS ... SMDERF, SMDRFC.
C
C     THESE FUNCTIONS ARE COMPUTED FROM THE RATIONAL APPROXIMATIONS OF
C     W.J.CODY, MATHEMATICS OF COMPUTATION, VOLUME 22 (1969), PAGES
C     631-637.
C
C     FOR ABS(X) LE 0.47 THE BASIC FUNCTION IS ERF.  FOR ABS(X) GT 0.47
C     THE BASIC FUNCTION IS ERFC.  THE FINAL RESULT IS OBTAINED IN TERMS
C     OF THE BASIC FUNCTION AS SHOWN IN THE FOLLOWING TABLE, IN WHICH
C     A=ABS(X).
C
C       FUNCTION     A.LE.(0.47)                   A.GT.(0.47)
C       REQUIRED       (ALL X)          (NEGATIVE X)       (POSITIVE X)
C
C       ERF(X)         ERF(X)             ERFC(A)-1          1-ERFC(X)
C
C       ERFC(X)       1-ERF(X)            2-ERFC(A)           ERFC(X)
C
C     ******************************************************************
C
      DATA  ZERO/ 0. D0 /,  ONE/ 1. D0 /,  TWO/ 2. D0 /,  FOUR/ 4. D0 /
C
      DATA ACUT/ 0.46875 D0 /
C     ( ACUT AND 4.0 ARE CHANGE-OVER POINTS FOR THE RATIONAL APPROXIM-
C     ATIONS. )
C
      DATA CONST/ 0.56418 95835 47756 3 D0 /
C     ( CONST=SQRT(1/PI). )
C
      DATA XMAX/ 8.9 D0 /
C     ( XMAX=SQRT(-ALOG(RMIN)-10.0), WHERE RMIN IS THE SMALLEST NORMAL-
C     IZED REPRESENTABLE NUMBER.  ERFC(XMAX) IS CLOSE TO THE UNDERFLOW
C     THRESHOLD. )
C
      DATA XUNIT/ 5.9 D0 /
C     ( XUNIT=SQRT(-ALOG(RELPR)+1.0), WHERE RELPR IS THE SMALLEST NUMBER
C     FOR WHICH 1.0+RELPR DIFFERS FROM 1.0.  ERF(XUNIT) IS INDISTIN-
C     GUISHABLE FROM 1.0. )
C
      DATA P1/ 2.42667 95523 05318 D+2,
     *         2.19792 61618 29415 D+1,
     *         6.99638 34886 19136 D+0,
     *        -3.56098 43701 81538 D-2 /
      DATA Q1/ 2.15058 87586 98612 D+2,
     *         9.11649 05404 51490 D+1,
     *         1.50827 97630 40779 D+1 /
      DATA P2/ 3.00459 26102 01616 D+2,
     *         4.51918 95371 18729 D+2,
     *         3.39320 81673 43437 D+2,
     *         1.52989 28504 69404 D+2,
     *         4.31622 27222 05674 D+1,
     *         7.21175 82508 83094 D+0,
     *         5.64195 51747 89740 D-1,
     *        -1.36864 85738 27167 D-7 /
      DATA Q2/ 3.00459 26095 69833 D+2,
     *         7.90950 92532 78980 D+2,
     *         9.31354 09485 06096 D+2,
     *         6.38980 26446 56312 D+2,
     *         2.77585 44474 39876 D+2,
     *         7.70001 52935 22947 D+1,
     *         1.27827 27319 62942 D+1 /
      DATA P3/-2.99610 70770 35422 D-3,
     *        -4.94730 91062 32507 D-2,
     *        -2.26956 59353 96869 D-1,
     *        -2.78661 30860 96478 D-1,
     *        -2.23192 45973 41847 D-2 /
      DATA Q3/ 1.06209 23052 84679 D-2,
     *         1.91308 92610 78298 D-1,
     *         1.05167 51070 67932 D+0,
     *         1.98733 20181 71353 D+0 /
C
C     ******************************************************************
C
C  ENTRY SMDERF.
      LERF=.TRUE.
      T=DX
      A=ABS(T)
      IF (A.GT.XUNIT) THEN
         SMDERF=SIGN(ONE,T)
         RETURN
      ENDIF
      GO TO 1
C
C  ENTRY SMDRFC.
      ENTRY SMDRFC(DX)
      LERF=.FALSE.
      T=DX
      A=ABS(T)
      IF (T.LT.-XUNIT) THEN
         SMDRFC=TWO
         RETURN
      ELSEIF (T.GT.XMAX) THEN
         SMDRFC=ZERO
         RETURN
      ENDIF
C
C  COMMON CODE.
C
    1 S=T**2
      IF (A.LE.ACUT) THEN
C
C  SET Y=SMDERF(X) AND TERMINATE.
C
         Y=T*(P1(1)+S*(P1(2)+S*(P1(3)+S*P1(4))))
     *      /(Q1(1)+S*(Q1(2)+S*(Q1(3)+S)))
         IF (LERF) THEN
            SMDERF=Y
         ELSE
            SMDRFC=ONE-Y
         ENDIF
C
      ELSE
C
C  SET Y=SMDRFC(A) AND TERMINATE.
C
         IF (A.LE.FOUR) THEN
            Y=EXP(-S)*(P2(1)+A*(P2(2)+A*(P2(3)+A*(P2(4)+A*(P2(5)+
     *              A*(P2(6)+A*(P2(7)+A*P2(8))))))))
     *               /(Q2(1)+A*(Q2(2)+A*(Q2(3)+A*(Q2(4)+A*(Q2(5)+
     *              A*(Q2(6)+A*(Q2(7)+A)))))))
         ELSE
            R=ONE/A
            U=R**2
            Y=R*EXP(-S)*( CONST +
     *           U*(P3(1)+U*(P3(2)+U*(P3(3)+U*(P3(4)+U*P3(5)))))
     *            /(Q3(1)+U*(Q3(2)+U*(Q3(3)+U*(Q3(4)+U)))) )
         ENDIF
         IF (LERF) THEN
            SMDERF=SIGN(ONE-Y,T)
         ELSE
            IF (T.GE.ZERO) THEN
               SMDRFC=Y
            ELSE
               SMDRFC=TWO-Y
            ENDIF
         ENDIF
C
      ENDIF
      RETURN
C
      END
C------------------------------------------------------------------------
      FUNCTION SMFREQ(RX)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      REAL SMFREQ,RX,ROUND
C
      DATA CONST/ 0.70710 67811 86548 D0 /
C     ( CONST=SQRT(1/2). )
C
      DATA XMAX/ 8.9 D0 /
C     ( XMAX=SQRT(-ALOG(RMIN)-10.0), WHERE RMIN IS THE SMALLEST NORMAL-
C     IZED REPRESENTABLE NUMBER.  ERFC(XMAX) IS CLOSE TO THE UNDERFLOW
C     THRESHOLD. )
C
C     ******************************************************************
C
C  STATEMENT FUNCTION.
      ROUND(D)=SNGL(D+(D-DBLE(SNGL(D))))
C
C     ******************************************************************
C
C  START.
      CX=CONST*DBLE(RX)
      IF(CX.LT.-XMAX) THEN
         SMFREQ=0.D0
      ELSE
         IF(CX.GE.0.D0) SMFREQ = ROUND( 0.5D0 + 0.5D0*SMDERF(CX) )
         IF(CX.LT.0.D0) SMFREQ = ROUND( 0.5D0*SMDRFC(-CX) )
      ENDIF
      RETURN
      END
C------------------------------------------------------------------------
      FUNCTION SMGSIN(P)
C    THIS ROUTINE COMPUTES THE INVERSE OF THE DISTRIBUTION
C    FUNCTION OF THE STANDARD NORMAL DISTRIBUTION.
C     THE ROUTINE WAS WRITTEN BY S.W. CUNNINGHAM
C     APPLIED STATISTICS ALGORITHM AS 24
C    AT LEAST 9 SIGNIFICANT FIGURES ARE CORRECT.
      DIMENSION A(5),CONNOR(17),HSINGS(6)
C      DATA RTHFPI,RRT2PI,TERMIN/1.2533141373,0.3989422804,1.E-11/
      DATA RTHFPI,RRT2PI,TERMIN/1.2533141373,0.3989422804,2.E-7/
      DATA CONNOR
     1/8.0327350124E-17,1.4483264644E-15,2.4668270103E-14,
     23.9554295164E-13,5.9477940136E-12,8.3507027951E-11,
     31.0892221037E-9,1.3122532964E-8,1.4503852223E-7,
     41.4589169001E-6,1.3227513228E-5,1.0683760684E-4,
     57.5757575758E-4,4.6296296296E-3,2.3809523810E-2,
     60.1,0.333333333333/
      DATA HSINGS
     1/2.515517,0.802853,0.010328,1.432788,0.189269,0.001308/
      IF(P .LE. 0. .OR. P .GE. 1.) GO TO 8
C    GET FIRST APPROXIMATION BY HASTINGS FORMULA
      B=P
      IF(B .GT. 0.5) B=1.-B
      F=-ALOG(B)
      E=SQRT(F+F)
      XO=-E+((HSINGS(3)*E+HSINGS(2))*E+HSINGS(1))/(((HSINGS(6)*E+HSINGS
     1(5))*E+HSINGS(4))*E+1.)
      IF(XO .LT. 0.) GO TO 1
      XO=0.
      PO=0.5
      X1=-RTHFPI
      GO TO 7
C    FIND THE AREA CORRESPONDING TO X0
    1 Y=XO*XO
      IF(XO .LE. -1.9) GO TO 3
      Y=-0.5*Y
C    SERIES APPROXIMATION
      PO=CONNOR(1)
      DO 2 L=2,17
    2 PO=PO*Y+CONNOR(L)
      PO=(PO*Y+1.)*XO
      X1=-(PO+RTHFPI)*EXP(-Y)
      PO=PO*RRT2PI+0.5
      GO TO 7
C    CONTINUED FRACTION APPROXIMATION
    3 Z=1./Y
      A(2)=1.
      A(3)=1.
      A(4)=Z+1.
      A(5)=1.
      W=2.
    4 CONTINUE
      DO 6 L=1,3,2
      DO 5 J=1,2
      K=L+J
      KA=7-K
    5 A(K)=A(KA)+A(K)*W*Z
    6 W=W+1.
      APPRXU=A(2)/A(3)
      APPRXL=A(5)/A(4)
      C=APPRXU-APPRXL
      IF(C .GE. TERMIN) GO TO 4
      X1=APPRXL/XO
      PO=-X1*RRT2PI*EXP(-0.5*Y)
C    GET ACCURATE VALUE BY TAYLOR EXPANSION
    7 D=F+ALOG(PO)
      X2=XO*X1*X1-X1
      X3=(X1*X1+2.*XO*X2)*X1-X2
      X=((X3/3.*D+X2)*D*0.5+X1)*D+XO
      IF(P .GT. 0.5) X=-X
      SMGSIN=X
      RETURN
    8 PRINT 9, P
      STOP
    9 FORMAT(/10X,11HARGUMENT P=,E15.5,17HIN SMGSIN ILLEGAL/)
      END
C------------------------------------------------------------------------
      Subroutine SMhard
C--Off-shell hard cross section
      Include 'SMallx.inc'
      Real Enjtrg,Sig,SMimpf,ptj,costh,ptr,pcm,SMrgen,
     & k1(5),k2(5),khat(5)
      Integer I
      Wsig=0.0
      If (Excode.ne.0.0) return
      If (Wini.eq.0.0) return
      If (hspot) then
C--Look for trigger jet
        Enjtrg=0.
        Do 700 I=Ifin+1,Jfin
        ptj=sqrt(P(1,I)**2+P(2,I)**2)
        If (P(3,I)+P(4,I).gt.Ppjtrg.and.ptj.gt.Ptjtrg.and.
     &     ptj.gt.P(3,I)*Thjtrg) Enjtrg=Enjtrg+1.
  700   Continue
        If (Enjtrg.eq.0.) return
        Wt=Wt*Enjtrg
      Endif
c--Generate p3 in hard cmf
      Call SMvsum(4,q1,q2,khat)
      Call SMumas(khat)
      If (khat(5).lt.2.*Qmas) then
        Call Gfill1(98,27.,P(6,I))
        Call Gfill1(99,27.,1.)
        return
      Endif
      p3(5)=Qmas
      p3(4)=0.5*khat(5)
      pcm=Sqrt(p3(4)**2-p3(5)**2)
      costh=2.*SMrgen(1)-1.
      p3(3)=pcm*costh
      ptr=Sqrt(pcm**2-p3(3)**2)
      Call SMrazm(ptr,p3(1),p3(2))
c--Boost to lab
      Call SMulob(khat,p3,p3)
      Call SMvdif(4,khat,p3,p4)
      p4(5)=Qmas
c--Compute cross section contribution
c--Delete + component for photon
      k1(1)=q1(1)
      k1(2)=q1(2)
      k1(3)=0.5*(q1(3)-q1(4))
      k1(4)=-k1(3)
      Call SMumas(k1)
c--Delete - component for gluon
      k2(1)=q2(1)
      k2(2)=q2(2)
      k2(3)=0.5*(q2(3)+q2(4))
      k2(4)=k2(3)
      Call SMumas(k2)
      If (onel) then
c--Use on-shell cross section with cutoff on Qt
        If (k2(5).lt.Qhard) then
          k2(1)=0.
          k2(2)=0.
          k2(5)=0.
        Else
          Wsig=0.
          Return
        Endif
      Endif
      Sig=SMimpf(p1,p2,k1,k2,costh,Qmas,2,Ichg)/137.
      If (Sig.le.0.) return
      Wsig=Wt*Wini*Sig
      End
C----------------------------------------------------------------------
      Subroutine SMhevt
C   Puts current event data into LEP standard common block HEPEVT
C----------------------------------------------------------------------
      Include 'SMallx.inc'
      Integer NMXHEP,NEVHEP,NHEP,ISTHEP,IDHEP,JMOHEP,JDAHEP,
     & MHEP,IHEP,JHEP,I,J
      Real PHEP,VHEP,EVWGT
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
C---Event weight
C   N.B. weights must be renormalized to momentum sum
      COMMON/HEPWGT/EVWGT
      EVWGT=Wsig
      NEVHEP=Jev
      NHEP=0
      If (EVWGT.eq.0.) return
      NHEP=Jfin+8
      MHEP=NHEP-1
      ISTHEP(1)=3
      ISTHEP(2)=3
      ISTHEP(3)=1
      ISTHEP(4)=1
      ISTHEP(5)=2
      ISTHEP(MHEP)=1
      ISTHEP(NHEP)=1
      IDHEP(1)=11
      IDHEP(2)=2212
      IDHEP(3)=11
      IDHEP(4)=0
      IDHEP(5)=22
      IDHEP(MHEP)=Idq
      IDHEP(NHEP)=-Idq
      JMOHEP(1,1)=0
      JMOHEP(2,1)=0
      JMOHEP(1,2)=0
      JMOHEP(2,2)=0
      JMOHEP(1,3)=1
      JMOHEP(2,3)=0
      JMOHEP(1,4)=2
      JMOHEP(2,4)=0
      JMOHEP(1,5)=1
      JMOHEP(2,5)=0
      JMOHEP(1,MHEP)=5
      JMOHEP(2,MHEP)=Ifin+6
      JMOHEP(1,NHEP)=5
      JMOHEP(2,NHEP)=Ifin+6
      JDAHEP(1,1)=3
      JDAHEP(2,1)=5
      JDAHEP(1,2)=4
      JDAHEP(2,2)=6
      JDAHEP(1,3)=0
      JDAHEP(2,3)=0
      JDAHEP(1,5)=MHEP
      JDAHEP(2,5)=NHEP
      JDAHEP(1,MHEP)=0
      JDAHEP(2,MHEP)=0
      JDAHEP(1,NHEP)=0
      JDAHEP(2,NHEP)=0
      Call SMvequ(5,p1,PHEP(1,1))
      Call SMvequ(5,p2,PHEP(1,2))
      Call SMvequ(5,espec,PHEP(1,3))
      Call SMvequ(5,pspec,PHEP(1,4))
      Call SMvequ(5,q1,PHEP(1,5))
      Call SMvequ(5,p3,PHEP(1,MHEP))
      Call SMvequ(5,p4,PHEP(1,NHEP))
      IHEP=5
      Do 10 I=0,Ifin
      IHEP=IHEP+1
      IDHEP(IHEP)=21
      JMOHEP(1,IHEP)=IHEP-1
      JMOHEP(2,IHEP)=0
      JDAHEP(1,IHEP)=IHEP+1
      JDAHEP(2,IHEP)=0
      Call SMvequ(5,P(1,I),PHEP(1,IHEP))
   10 Continue
      ISTHEP(IHEP)=2
      JDAHEP(1,IHEP)=MHEP
      JDAHEP(2,IHEP)=NHEP
      JMOHEP(1,6)=2
      Do 20 I=Ifin+1,Jfin
      IHEP=IHEP+1
      J=Abs(P(7,I))+0.5
      JHEP=J+5
      If (P(7,J).ne.0.) JHEP=JHEP+1
      ISTHEP(IHEP)=1
      ISTHEP(JHEP)=2
      IDHEP(IHEP)=21
      JMOHEP(1,IHEP)=JHEP
      JMOHEP(2,IHEP)=0
      If (JDAHEP(1,JHEP).EQ.0) then
        JDAHEP(1,JHEP)=IHEP
      Else        
        JDAHEP(2,JHEP)=IHEP
      Endif
      JDAHEP(1,IHEP)=0
      JDAHEP(2,IHEP)=0
      Call SMvequ(5,P(1,I),PHEP(1,IHEP))
   20 Continue
      End
C----------------------------------------------------------------------
      Function SMimpf(p1,p2,k1,k2,costh,mQ,iproc,ichrg)
C
C   iproc=1 for gamma-gamma,  2 for gamma-gluon,  3 for gluon-gluon
C   ichrg=1 for |charge|=1/3, 2 for |charge|=2/3, 3 for u+d+s.
C
C   In notation of Catani et al., Cavendish-HEP-90/27
C   SMimpf  = d\hat\sigma/d\Omega_{34}/M^2 in nb/GeV^2
C   so that e.g. for electroproduction
C   d\sigma = \alpha dQ^2/Q^2 dx/x dy/y d^2k_t d\Omega_{34}/(4\pi)
C            * F(x,k_t) * SMimpf(p1,p2,q,k,p3,p4,mQ,2,3eQ)
C   where \int_0^Q F(x,k_t) d^2k_t = xG(x,Q)
C
C   This version generates the heavy quark momenta p3,p4
C
      Implicit none
      Real p1(5),p2(5),k1(5),k2(5),p3(5),p4(5),SMimpf,SMuldo,p1p2,p1p3,
     & p1p4,p2p3,p2p4,p1k2,p2k1,p3k1,p3k2,p4k1,p4k2,k1k2,k12,k22,M2,
     & rs,rt,ru,sL,Del,pkp,Aab,Ana,Cab,Cna,Gevnb,alphas,alphaq,alsf,
     & Nc,V,one,two,half,four,Sigfac,Rlamsq,freeze,eps,Scale,e1,e2,
     & khat(5),mQ,pcm,SMrgen,costh
      Integer iproc,ichrg
C   alphaq=1./137./9., alsf=12.*pi/23.
      Data Nc,V,one,two,half,four,alphaq/3.,8.,1.,2.,0.5,4.,8.11E-4/
      Data Gevnb,Rlamsq,alsf,freeze,eps/3.894E5,25.,1.639,5.15,1.E-6/
      SMimpf=0.
      Call SMvsum(4,k1,k2,khat)
      Call SMumas(khat)
      If (khat(5).lt.two*mQ) return
      M2=mQ**2
c--Generate p3 in hard cmf
      p3(5)=mQ
      p3(4)=half*khat(5)
      pcm=Sqrt(p3(4)**2-p3(5)**2)
      p3(3)=pcm*costh
      p3(1)=Sqrt(pcm**2-p3(3)**2)
      p3(2)=0.
c--Boost to lab
      Call SMulob(khat,p3,p3)
      Call SMvdif(4,khat,p3,p4)
      p4(5)=mQ
c
      p1p2=SMuldo(p1,p2)
      p1p3=SMuldo(p1,p3)
      p1p4=SMuldo(p1,p4)
      p2p3=SMuldo(p2,p3)
      p2p4=SMuldo(p2,p4)
      p1k2=SMuldo(p1,k2)
      p2k1=SMuldo(p2,k1)
      p3k1=SMuldo(p3,k1)
      p3k2=SMuldo(p3,k2)
      p4k1=SMuldo(p4,k1)
      p4k2=SMuldo(p4,k2)
      k1k2=SMuldo(k1,k2)
      k12=-k1(5)**2
      k22=-k2(5)**2
      e1=-k12/M2
      e2=-k22/M2
      rs=one/khat(5)**2
      rt=one/(k12-two*p4k1)
      ru=one/(k22-two*p4k2)
      pkp=(p2k1*p1k2/p1p2**2)**2
      Ana=0.
      If (e1.lt.eps) then
        If (e2.lt.eps) then
          Aab=(p3k1**2+p4k1**2 + M2*(two*k1k2 - M2*k1k2**2
     &       /(p4k1*p3k1)))/(p4k1*p3k1)
          If (iproc.eq.3) Ana=(p3k1**2+p4k1**2 + M2*(two*k1k2
     &       - M2*k1k2**2/(p4k1*p3k1)))*(-two/k1k2**2)
        Else
          Aab=(k1k2/p2k1)**2*((p2p3**2+p2p4**2)/(p4k1*p3k1)
     &       -two*M2*(p2p4/p3k1-p2p3/p4k1)**2/k22)
          If (iproc.eq.3) Ana=(k1k2/p2k1)**2*((p2p3**2+p2p4**2)
     &    /(p4k1*p3k1)*(two*rs*(p4k1*p2p3+p3k1*p2p4)/p2k1-one)-four*
     &    M2*(two*rs*p2k1-p2p4/p3k1)*(two*rs*p2k1-p2p3/p4k1)/k22)
        Endif
      Elseif (e2.lt.eps) then
          Aab=(k1k2/p1k2)**2*((p1p3**2+p1p4**2)/(p4k2*p3k2)
     &       -two*M2*(p1p4/p3k2-p1p3/p4k2)**2/k12)
          If (iproc.eq.3) Ana=(k1k2/p1k2)**2*((p1p3**2+p1p4**2)
     &    /(p4k2*p3k2)*(two*rs*(p4k2*p1p3+p3k2*p1p4)/p1k2-one)-four*
     &    M2*(two*rs*p1k2-p1p4/p3k2)*(two*rs*p1k2-p1p3/p4k2)/k12)
      Else
        Aab=four*pkp*( p1p2**2*rt*ru - (p1p2 + two*p1p4*p2p3*rt
     &     + two*p1p3*p2p4*ru)**2/(k12*k22) )
        If (iproc.eq.3) then
        Del=two*rs*p1p2*(two*p1p3*p2p4/p1p2 - two*p1p4*p2p3/p1p2
     &     - k12*p1p4/p1k2 + k22*p2p4/p2k1 + p4k1 - p4k2)
        Ana=pkp*( four*p1p2**2*( -rt*ru
     &    - rs*(rt-ru)*(p1p3/p1k2-p2p3/p2k1)
     &    + rs*p1p2/(p1k2*p2k1) ) + two*(p1p2 + four*p1p4*p2p3*rt
     &    - Del)*(p1p2 + four*p1p3*p2p4*ru + Del)/(k12*k22) )
        Endif
      Endif
      sL=two*p2k1*p1k2/p1p2
      Sigfac=Gevnb*sqrt(one-four*rs*M2)/sL
      Cna=0.
      If (iproc.eq.1) then
        Cab=two*alphaq**2
        If (ichrg.eq.2) Cab=Cab*four**2
        If (ichrg.eq.3) Cab=Cab*(two+four**2)
      Else
        Scale=two*(sL*rt*ru)/((sL*rt*ru)**2+rt**2+ru**2)
        If (Scale.lt.0.) then
          Call SMwarn
          Print *,' sL,rt,ru =',sL,rt,ru
          Scale=0.
        Endif
        alphas=alsf/Log(Scale*Rlamsq+freeze)
        If (iproc.eq.2) then
          Cab=alphaq*alphas
          If (ichrg.eq.2) Cab=Cab*four
          If (ichrg.eq.3) Cab=Cab*(two+four)
        Else
          Cab=half*alphas**2/Nc
          Cna=half*alphas**2*Nc/V
        Endif
      Endif
      SMimpf=(Cab*Aab+Cna*Ana)*Sigfac
      If (SMimpf.lt.0.) SMimpf=0.
      End
C----------------------------------------------------------------------
      Subroutine SMinfn
C--Choose starting conditions for branching
      Include 'SMallx.inc'
      Real SMrgen,SMrgau,u,yinf,frat,Qinf,Qsup

      Jev=Jev+1
c changed hannes:       Call SMrget(Js)
c--choose initial x
      If (powin) then
c--power input
   10 continue
        If (pow0.ne.0.) then
          x0=xmin*(1.-xmp0*SMrgen(2))**q0
        Else
          x0=xmin**SMrgen(3)
        Endif
        If ((1.-x0)**pow1.lt.SMrgen(4)) go to 10
      Else
c--1 loop input exp(a0*sqrt(ln1/x))
   11   continue
        u=Log(1.+emax*SMrgen(5))/a0
        x0=Exp(-u*u)
        If (u*(1.-x0)**pow1.lt.umax*SMrgen(6)) go to 11
      Endif
c--choose starting Qt
      P(1,0)= SMrgau(1,0.0,Qx)
      P(2,0)= SMrgau(2,0.0,Qx)
c--compute xgbar
      xg=x0
      xgbar=-(P(1,0)**2+P(2,0)**2+p2(5)**2*x0*(2.-x0))
     &      /(Sbig*(1.-x0))
      P(3,0)=x0*p2(3)+xgbar*p1(3)
      P(4,0)=x0*p2(4)+xgbar*p1(4)
      Call SMumas(P(1,0))
c--proton spectator
      Call SMvdif(4,p2,P(1,0),pspec)
c--choose y
      yinf=xymin/x0
      If (yinf.lt.ymin) yinf=ymin
      If (yinf.le.ymax) then
        frat=Log(ymax/yinf)
        yphton=yinf*Exp(frat*SMrgen(1))
        Wini=frat
      Else
        yphton=ymax
        Wini=0.0
      Endif        
c--choose Sqrt(Q**2)
      Qinf=yphton*me/Sqrt(1.-yphton)
      If (Qinf.lt.Qmin) Qinf=Qmin
      Qsup=Sqrt(yphton*Sbig)
      If (Qsup.gt.Qmax) Qsup=Qmax
      If (Qinf.le.Qsup) then
        frat=Log(Qsup/Qinf)
        Qval=Qinf*Exp(frat*SMrgen(3))
        Wini=Wini*frat*(1.+(1.-yphton)**2)
      Else
        Qval=Qsup
        Wini=0.0
      Endif
      Call SMrazm(Qval*Sqrt(1.-yphton),q1(1),q1(2))
      yphbar=-Qval**2/Sbig
      q1(3)=yphton*p1(3)+yphbar*p2(3)
      q1(4)=yphton*p1(4)+yphbar*p2(4)
c--electron spectator
      Call SMvdif(4,p1,q1,espec)
      Wt=1.
      q1(5)=-Qval
      P(6,0)=Wt
      P(7,0)=0.
      P(8,0)=0.
      Return
      End
C------------------------------------------------------------------------
      Subroutine SMprev
C--Prints event
      Include 'SMallx.inc'
      Integer NMXHEP,NEVHEP,NHEP,ISTHEP,IDHEP,JMOHEP,JDAHEP
      Real PHEP,VHEP,EVWGT
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
C---Event weight
C   N.B. weights must be renormalized to momentum sum
      COMMON/HEPWGT/EVWGT
      Real QQ,Wold,Wnew,Ql,Pold,z
      Integer I,J,Ipar,Jpar
      QQ=0.
      Print 1,Jev,Js,P(6,Ifin)
    1 Format(//9X,'Event:',I7,'   Seed: ',I12//
     &9X,'Branching record: Weight =',1PE13.4//
     &3X,'I   K         E         Qt       Ql        z      Wt')
      Wold=P(6,0)
      Do 10 I=0,Jfin
      QQt=Sqrt(P(1,I)**2+P(2,I)**2)
      Ipar=Ifix(Abs(P(7,I))+0.5)
      If (Ipar.eq.0) then
        Ipar=Max(I-1,0)
      Else
        Jpar=Ifix(Abs(P(7,Ipar))+0.5)
        If (Jpar.eq.0) Ipar=Ipar-1
      Endif
      Pold=P(3,Ipar)+P(4,Ipar)
      If (Pold.eq.0.) then
        z=0.
      Else
        z=(P(3,I)+P(4,I))/Pold
      Endif
      If (Wold.eq.0.) then
        Wnew=0.
      Else
        If (P(7,I).eq.0.) then
          Wnew=P(6,I)/Wold
        Else
          Wnew=1.
        Endif
      Endif
      Wold=P(6,I)
      Print 5,I,P(7,I),P(4,I),QQt,P(3,I),z,Wnew
    5 Format(I4,F5.0,1PE12.4,0P4F9.4)
   10 Continue
      If (EVWGT.le.0.) then
        Print 20, EVWGT
   20   FORMAT(/9X,'No HEPEVT record: EVWGT  =',1PE13.4)
      Else
        Print 30, EVWGT
   30   FORMAT(/9X,'HEPEVT record:    EVWGT  =',1PE13.4//
     &  '  IHEP IDPDG IST MO1 MO2 DA1 DA2   ',
     &  ' P-X     P-Y      P-Z    ENERGY    MASS')
        Do 40 I=1,NHEP
        Print 50, I,IDHEP(I),ISTHEP(I),JMOHEP(1,I),JMOHEP(2,I),
     &  JDAHEP(1,I),JDAHEP(2,I),(PHEP(J,I),J=1,5)
   40   Continue
      Endif
   50 FORMAT(I5,1X,I6,5I4,2F8.2,2F9.2,F8.2)
      End
C------------------------------------------------------------------------
      Subroutine SMqtem(Tlike)
C--Finds Qtem
      Include 'SMallx.inc'
      Real Eps,U0,Ul,R,SMrgen,D,C,U,Un
      Integer n
      Logical Tlike
      Data Eps/1.E-5/
      U0=Told/Tg
      Ul=U0*Log(U0)
      R=SMrgen(1)
      If (R.eq.0.) R=Eps
      D=-Log(R)/(Tg*Capb)
      If (Tlike) D=-D
      If (afix) then
        C=U0-Log(U0)+D
        If (C.le.1.) then
          Qtem=Qg
          Ttem=Tg
          return
        Endif
        U=U0+D
        Do 10 n=1,100
        If (U.le.1.) then
          Print *,'Found U<1!! U,C,n =',U,C,n
          U=1.+Eps
        Endif
        Un=U*(C+Log(U)-1.)/(U-1.)
        If (Abs(Un-U).lt.Eps) go to 101
   10   U=Un
      Else
        C=Ul-U0+D
        If (C.le.-1.) then
          Qtem=Qg
          Ttem=Tg
          return
        Endif
C--First shot is quadratic
        U=U0-Ul+Sqrt(Ul*Ul+2.*D*U0)
        Do 100 n=1,100
        If (U.le.1.) then
          Print *,'Found U<1!! U,C,n =',U,C,n
          U=1.+Eps
        Endif
        Un=(U+C)/Log(U)
        If (Abs(Un-U).lt.Eps) go to 101
  100   U=Un
      Endif
      Print *,' Couldn''t find Qtem!! U,Un,C,D,U0 =',
     &                                U,Un,C,D,U0
  101 Ttem=Un*Tg
      If (Ttem.gt.50.) Ttem=50.
      Qtem=QCDLam*Exp(Ttem)
      End
C------------------------------------------------------------------------
      SUBROUTINE SMRAZM(PT,PX,PY)
C ... RANDOMLY ROTATED 2-VECTOR (PX,PY) OF LENGTH PT
      REAL RGEN,PT,PX,PY,C,S,CS,QT
   10 C=2.*SMRGEN(1)-1.
      S=2.*SMRGEN(2)-1.
      CS=C*C+S*S
      IF (CS.GT.1. .OR. CS.EQ.0) GO TO 10
      QT=PT/CS
      PX=(C*C-S*S)*QT
      PY=2.*C*S*QT
      END
C------------------------------------------------------------------------
      FUNCTION SMRGAU(J,A,B)
C ... Gaussian random number, mean A, standard deviation B.
      INTEGER J,I
      REAL A,B,X,R
      X=0.
      DO 1 I=1,12
      R=SMRGEN(I)
   1  X=X+R
      SMRGAU=A+B*(X-6.)
      END
C------------------------------------------------------------------------
      REAL FUNCTION SMRGEN(I)
C ... Main random number generator: replace RAN by another
C     pseudorandom number generator on [0,1] if necessary
      INTEGER I,ISEED,JSEED
      REAL SMRGET,SMRSET,RAN 
      Real Rvec(2)
      iseed =i
changed hannes:     SMRGEN=RAN(ISEED)
      CALL RANLUX(RVEC,1)
      SMRGEN=Rvec(1)
      RETURN
      ENTRY SMRSET(JSEED)
      ISEED=JSEED
      RETURN
      ENTRY SMRGET(JSEED)
      JSEED=ISEED
      END
C------------------------------------------------------------------------
      Subroutine SMtimb
C--Timelike branching of emitted gluons
      Include 'SMallx.inc'
      Real Qold,ynow,SMrgen,Qnow
      Integer I,J,K
      If (Ifin.eq.0) return
      Wt=P(6,Ifin)
      J=Ifin
      Do 500 I=1,Ifin
      J=J+1
      If (J.gt.Imax) then
        Print *, ' Ran out of space on event',Jev
C        Call SMprev
        Jfin=Imax

        return
      Endif
      Qold=P(8,I)
      Told=Log(Qold/QCDLam)
      Call SMvdif(4,P(1,I-1),P(1,I),P(1,J))
c--Set mass to 0 (NB timelike masses yet to be included)
      P(5,J)=0.
      P(6,J)=1.
      P(7,J)=Float(I)
      P(8,J)=Qold
      K=J                      
  100 continue
      If (Told.le.Tg) then
        Jfin=J
        Told=Tg+1.E-5
      Endif
      If (tevol) then
        Call SMqtem(.true.)
      Else
        Ttem=Tg
      Endif
      If (Ttem.lt.Tgg) then
        P(7,K)=-P(7,K)
        If (K.eq.J) then
C--Finished this jet
          go to 500
        Else
c--Check next branch
          K=K+1
          Told=Log(P(8,K)/QCDLam)
          go to 100
        Endif
      Else
C--Choose large z
        ynow=Exp(Ttem*(Tg/Ttem)**SMrgen(1)-Ttem)
        znow=1.-ynow
        Qnow=znow*Qtem
        If (Qnow.lt.Qg) then
C--Outside phase space
          Told=Ttem
          go to 100
        Else
C--Store new branches
C  n.b. First branch will tend to have larger z
          J=J+1
          Call SMvsca(5,znow,P(1,K),P(1,J))
          P(6,J)=1.
          P(7,J)=Float(K)
          P(8,J)=Qnow
          J=J+1
          Call SMvsca(5,ynow,P(1,K),P(1,J))
          P(6,J)=1.
          P(7,J)=Float(K)
          P(8,J)=Qtem-Qnow
c--Check next branch
          K=K+1
          Told=Log(P(8,K)/QCDLam)
          go to 100
        Endif
      Endif
  500 continue
      Jfin=J
      End
C----------------------------------------------------------------------
      REAL FUNCTION SMULDO(P,Q)
C---LORENTZ 4-VECTOR DOT PRODUCT
      REAL P(4),Q(4)
      SMULDO=-0.5*((P(3)+P(4))*(Q(3)-Q(4))+(P(3)-P(4))*(Q(3)+Q(4)))
     &       -P(1)*Q(1)-P(2)*Q(2)
      END
C-----------------------------------------------------------------------
      SUBROUTINE SMULOB(PS,PI,PF)
C     TRANSFORMS PI (GIVEN IN REST FRAME OF PS) INTO PF (IN LAB)
C     N.B. P(1,2,3,4,5) = (PX,PY,PZ,E,M)
C-----------------------------------------------------------------------
      REAL PF4,FN,PS(5),PI(5),PF(5)
      IF (PS(4).EQ.PS(5)) THEN
        PF(1)= PI(1)
        PF(2)= PI(2)
        PF(3)= PI(3)
        PF(4)= PI(4)
      ELSE
        PF4  = (PI(1)*PS(1)+PI(2)*PS(2)
     &         +PI(3)*PS(3)+PI(4)*PS(4))/PS(5)
        FN   = (PF4+PI(4)) / (PS(4)+PS(5))
        PF(1)= PI(1) + FN*PS(1)
        PF(2)= PI(2) + FN*PS(2)
        PF(3)= PI(3) + FN*PS(3)
        PF(4)= PF4
      END IF
      PF(5)= PI(5)
      END
C-----------------------------------------------------------------------
      SUBROUTINE SMUMAS(P)
C---PUTS MASS IN P(5) (-|MASS| IF SPACELIKE)
      REAL P(5),EM
      EM=(P(4)+P(3))*(P(4)-P(3))-P(1)**2-P(2)**2
      IF (EM.GE.0.) THEN
        P(5)=SQRT(EM)
      ELSE
        P(5)=-SQRT(-EM)
      ENDIF
      END
C------------------------------------------------------------------------
      REAL FUNCTION SMURAP(P)
C     TRUE RAPIDITY
C------------------------------------------------------------------------
      REAL P(4)
      If (P(3).ge.P(4)) then
        SMURAP=1000.
      Elseif (P(3).le.-P(4)) then
        SMURAP=-1000.
      Else
        SMURAP=0.5*Log((P(4)+P(3))/(P(4)-P(3)))
      Endif
      END
C------------------------------------------------------------------------
      SUBROUTINE SMVDIF(N,P,Q,R)
C---VECTOR DIFFERENCE
      INTEGER N,I
      REAL P(N),Q(N),R(N)
      DO 10 I=1,N
   10 R(I)=P(I)-Q(I)
      END
C------------------------------------------------------------------------
      SUBROUTINE SMVEQU(N,P,Q)
C---VECTOR EQUALITY
      INTEGER N,I
      REAL P(N),Q(N)
      DO 10 I=1,N
   10 Q(I)=P(I)
      END
C------------------------------------------------------------------------
      SUBROUTINE SMVSCA(N,C,P,Q)
C---VECTOR TIMES SCALAR
      INTEGER N,I
      REAL C,P(N),Q(N)
      DO 10 I=1,N
   10 Q(I)=C*P(I)
      END
C------------------------------------------------------------------------
      SUBROUTINE SMVSUM(N,P,Q,R)
C---VECTOR SUM
      INTEGER N,I
      REAL P(N),Q(N),R(N)
      DO 10 I=1,N
   10 R(I)=P(I)+Q(I)
      END
C------------------------------------------------------------------------
      Subroutine SMwarn
      Include 'SMallx.inc'
      Integer Nerr
      Data Nerr/0/
      Nerr=Nerr+1
      Print *,' Error called from SMimpf: negative scale'
      Call SMprev
      If (Nerr.gt.50) then
        Call SMaend
        Stop
      Endif
      End
C------------------------------------------------------------------------
      Subroutine SMzval
C--Chooses momentum fraction z for small-x branching
C  Cleaned-up version 24/10/91
C  All-loop has norm'n of small z part with no zmin
C------------------------------------------------------------------------
      Include 'SMallx.inc'
      Common/gcom/g0,g1,gtot
      Real asb,g0,g1,TQt,zmax,F,Ff,gtot,S2asb,arg,SMfreq,SMgsin,SMrgen
      Real Fmin,Fmax
      Data Fmin,Fmax/0.0000001,0.9999999/
      TQt=Log(QQt/QCDLam)
      asb= .5*Capb/TQt
      zmax=(1.-Qg/Qtem)
      g1 = .5*Capb*Log(Ttem/Tg)
      If (onel) then
        g0=0.
        If (zmax.gt.xmin) g0=asb*log(zmax/xmin)
        gtot=g0+g1
        If (SMrgen(1)*gtot.le.g1) then
           znow=1.-exp(Ttem*((Tg/Ttem)**SMrgen(2)-1.))
        Else
           Nsoft=Nsoft+1
           znow=xmin*(zmax/xmin)**SMrgen(3)
        Endif
      Else
        S2asb=Sqrt(2.*asb)
        arg=S2asb*(Ttem-TQt+Log(zmax))
        F=SMfreq(arg)
        Ff=SMfreq(arg-1./S2asb)
        If (Ff*QQt.le.0.) then
          g0=0.
        Else
          g0=asb*exp(-0.25/asb)*F*Qtem/(Ff*QQt)
        Endif
        gtot=g0+g1
        If (SMrgen(1)*gtot.le.g1) then
           znow=1.-exp(Ttem*((Tg/Ttem)**SMrgen(2)-1.))
        Else
           Nsoft=Nsoft+1
           Ff=SMrgen(3)*F
           If (Ff.lt.Fmin) then
              znow=xmin*0.5
           Elseif (Ff.gt.Fmax) then
              znow=zmax*Fmax
           Else
              znow=QQt/Qtem*exp(SMgsin(Ff)/S2asb)
           Endif
        Endif
      Endif
      wg=gtot/g1
      End
      
      

